size(600, 450)
background(0)


import objc, AppKit, Foundation, os
base_path = '/Library/Frameworks'
bundle_path = os.path.abspath(os.path.join(base_path, 'CocoaSequenceGrabber.framework'))
objc.loadBundle('CocoaSequenceGrabber', globals(), bundle_path=bundle_path)



import Foundation
NSObject = Foundation.NSObject



# print "pysight", pysight.__file__

import pprint
import time

import objc


class LastImage(object):
    def __init__(self):
        print "LastImage.__init__()"
        self.image = None
    def setImage(self, image):
        print "LastImage.setImage()"
        if image == self.image:
            return
        if self.image != None:
            self.image.release()
        self.image = image
        self.image.retain()

    def getImage(self):
        print "LastImage.getImage()"
        if self.image == None:
            return False
        return self.image

theImage = LastImage()

class Controller(NSObject):

    def init(self):
        self = super(Controller, self).init()
        if self is None:
            return None

        # start frame grabbing
        # self.camera = pysight.CSGCamera.alloc().init()
        self.camera = CSGCamera.alloc().init()
        self.camera.setDelegate_(self)
        print "camera", repr(self.camera)
        print "delegate", repr(self.camera.delegate())

        return self

    def start(self):
        self.camera.startWithSize_( (800, 600) )


    # CSGCamera delegate
    # This method is called when the sequence grabber has a new frame (30 FPS)
    def camera_didReceiveFrame_(self, aCamera, aFrame):
        global counter
        imageRep = aFrame
        theImage.setImage( imageRep )
        counter += 1

# Create a grid of 3 x 3 with each image grabbed from the iSight.
# This will take some time.

# cam = IcamController.alloc().init()
cam = Controller.alloc().init()
cam.start()

for x, y in grid(3, 3, 200, 150):

    i = theImage.getImage()
    try:
        if i:
            image(None, x + 5, y + 5, image=i)
        else:
            print "Falser..."
    except Exception, err:
        print err

cam.camera.stop()
